;  IFN-SC/SCY/92 BIOS ROM CODE     1.10 2023-1-7, 1.30 2023-5-7
;       IFNUPROM.COM ̍\     0`0FCEh R[h, ȍ~16KB ROMf[^
DATA_OFFSET     equ     0FCEh           ; R[h̑傫
include  e:\asmlib\Instr486.INC         ; 486߃Zbg
code            segment public use16
                assume cs:code,ds:code,es:code,ss:code
                org 100h  ; MS-DOS COM`vO
start:          jmp     main    ; ɃWv
;------------ ROM CODE INSTRUCTIONS ----------------
.386
;----------------------------- static data ---------------------------
align 2
ROM_DATA_SIZE   DW      DATA_OFFSET + 4000h   ; t@CTCY=DATA_OFFSET+16K
WorkMemAddr     label   dword
DataBufferOfs   DW      0000h   ; Allocated by DOS int 21h,ah=48h
DataBufferSeg   DW      8000h   ; DOS allocated segment (ES)
CRLF            DB      13,10,0,0

ProgramTitle    DB    1Bh,"[47m"
DB " MELCO IFN-92/SC/SCY 2.13 BIOS̉ Version 1.32  Copyright(C) 2023 ܂ ",1Bh,"[m",13,10,0

ProgramTitle2   DB    "obt@[̃TCg_E[h, st@CœWJēꂽ",13,10
                DB    "uIFNUPROM.COMvJgfBNgɒuĉ.",13,10,0
align 16                ; filename string = 32 bytes
                DB    "o̧ٖ",0,0
InputFileName   DB "IFNUPROM.COM",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
OutputFileName  DB "IFNUPR8G.COM",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
msg_not98       DB      "This machine is not PC-9800 series",13,10,0
PatchJob        DB      "SCSI BIOS 8192V_(1GB)̃pb`s܂.",13,10
                DB      "yӁzΏۂi486ȏƂȂ, ȂƂ80286ȉœ삵ȂȂ܂.",13,10
                DB      "        8192MiBȏ̂Ƃ֐߂邩͏\Ɍ؂Ă܂. ",13,10
                DB      13,10,0

PatchJob2       DB      "[ZO~@\(div0rom)ǉ܂.",13,10,0
N_CR            DB      1Bh,"[41m N ",1Bh,"[m",13,10,0

Use386Machine   DB      "80386@ł\Ȃ悤ɂ܂H(y/n)      [ESC]Œ~ ",0

replace_as_div0 DB     1Bh,"[33m80386@ł͓삵ȂȂ܂ii486ȍ~Kvj.",1Bh,"[m ",13,10,13,10,0
ESC_CR          DB     1Bh,"[43m ESC ",1Bh,"[m",13,10,0
Y_CR            DB     1Bh,"[42m Y ",1Bh,"[m",13,10,0
replace_as_386  DB     "80386@ł삵܂, DIV0ROM@\͎g܂. ",13,10,13,10,0

code_replacing  DB      "ROM̃f[^ JMP $+2  out 5Fh,AL Œ܂(0`3FFF).",13,10,0
force_abort     DB      "vO̎s𒆒f܂.",13,10,0
err_abort       DB      "vOُ͈I܂.",13,10,0
jmp_5f          DB      "JMP $+2  out 5Fh,ALɕύX܂H(y/n)     [ESC]Œ~",13,10,"iύX9801FAȑŐ@Ŗ肪o邪, Pentium@œ\ɂȂj ",0
EndJob          DB      "I܂.   IFNUPR8G.COM ̂قsă{[hROMXVĉ.",13,10,0
Fail            DB      "pb`ł܂. z肵ĂȂo[Ŵ悤ł.",13,10,0
;----------------------------- data end ---------------------------------
.186            
DOS_PPROGRAM_AREA       label byte 
main:           mov     cx,4
                mov     bx,offset stackbase+1024        ; X^bN1024oCg
                shr     bx,cl
                add     bx,17
                mov     ah,4Ah  ; gpJ
                int 21h
                mov     ax,bx
                shl     ax,cl
                dec     ax
                mov     sp,ax           ; X^bN͂ύX

                mov     dx,offset ProgramTitle
                call    puts
                call    machine_check   ; XWǂ̃`FbN
                mov     al,0FFh         ; G[ԒlFF
                jc      ErrExitDOS      ; L[Β~

                call    AllocateBuf
                mov     es,DataBufferSeg

                call    LoadFile
                jc      ErrExitDOS
                mov     es,DataBufferSeg
                mov     dx,offset PatchJob
                call    puts
                call    Patch8192Cyln
                jc      PatchFail
                
                mov     dx,offset Use386Machine
                call    puts
KeyEnt1:        xor     ax,ax
                int     18h
                cmp     ah,00h  ; [ESC]
                je      ErrExitDOS2
                cmp     ah,15h  ; [Y]
                je      Patch386_OK
                cmp     ah,2Eh  ; [N]
                je      DIV0_OK
                call    ShortBeep
                jmp     KeyEnt1
Patch386_OK:
                mov     dx,offset Y_CR
                call    puts
                mov     dx,offset replace_as_386
                call    puts
                call    PatchFor80386
                jc      PatchFail
                jmp     NextStep

DIV0_OK:
                mov     dx,offset N_CR
                call    puts
                mov     dx,offset PatchJob2
                call    puts
                mov     dx,offset replace_as_div0
                call    puts
                call    PatchDiv0
                jc      PatchFail
                call    PatchDiv0Ent
                jc      PatchFail

NextStep:
                mov     dx,offset jmp_5f
                call    puts
                xor     ax,ax
                int     18h
                cmp     ah,00h  ; [ESC]
                je      ErrExitDOS2
                cmp     ah,15h  ; [Y]
                jne     @f
                mov     dx,offset Y_CR
                call    puts
                mov     dx,offset code_replacing
                call    puts
                call    Jmp2_Out5f
        @@:     
                mov     dx,offset CRLF
                call    puts

;;                call    CheckSum4KB_4

                mov     es,DataBufferSeg
                call    SaveToFile
                jc      ErrExitDOS
                mov     dx,offset EndJob
                call    puts
                mov     al,00h
                jmp     ExitDOS

ErrExitDOS2:    mov     dx,offset ESC_CR
                call    puts
                mov     dx,offset force_abort 
                call    puts
                mov     al,080h
                jmp     ExitDOS

PatchFail:      mov     dx,offset Fail
                call    puts
ErrExitDOS:     mov     dx,offset err_abort 
                call    puts
                mov     al,0FFh
ExitDOS:        mov     ah,4Ch
                int 21h
                RET

.386
;--------------------------------------------------------------------------
;       PatchFor80386   BSWAP eax  -->   CALL 0FD8h
;--------------------------------------------------------------------------
VACUNT_AREA     equ    ( 0FD8h + DATA_OFFSET )
PatchFor80386   PROC   near
                mov     si,offset Bswap1
                mov     cx,( offset Bswap1_E - offset Bswap1 )
                mov     di,DATA_OFFSET
                mov     dx,1000h
                push    cx
                call    scan_string
                pop     cx
                jc      Fail386Patch
                add     bx,4    ; call xxxx <-- forwarding 4 bytes
                mov     al,0E8h ;       (call) near instruction.
                mov     di,bx
                stosb
                mov     ax,VACUNT_AREA-3 ;  near address for call
                sub     ax,bx
                stosw

                mov     si,offset Bswap2
                mov     cx,( offset Bswap2_E - offset Bswap2 )
                mov     di,DATA_OFFSET
                mov     dx,1000h
                push    cx
                call    scan_string
                pop     cx
                jc      Fail386Patch
                add     bx,3    ; call xxxx <-- forwarding 4 bytes
                mov     al,0E8h ;       (call) near instruction.
                mov     di,bx
                stosb
                mov     ax,VACUNT_AREA-3 ;      calcurate  near address for call
                sub     ax,bx
                stosw

                mov     si,offset ByteSwap_EAX
                mov     cx,offset ByteSwap_EAX_E - offset ByteSwap_EAX
                mov     di,VACUNT_AREA
        rep     movsb

                clc
                ret
Fail386Patch:   stc
                ret

Bswap1    label   byte
                mov     eax,[bp+54h]    ; ax <==[bp+54],dx<==[bp+56]
                bswap   eax
Bswap1_E  label   byte

Bswap2    label   byte
                add     eax,ecx                 
                bswap   eax     ; 3 byte indtruction
Bswap2_E  label   byte

PatchFor80386   ENDP
.186

;--------------------------------------------------------------------------
;       PatchDiv0Ent    
;--------------------------------------------------------------------------
PatchDiv0Ent    PROC   near
                mov     di,0FE4h+DATA_OFFSET
                mov     si,offset SetVector00
                mov     cx,offset SetVector00_E - offset SetVector00
        rep     movsb

                mov     di,000Ch+DATA_OFFSET        ; ROM DATA INIT0 address
                mov     al,es:[di]
                cmp     al,0E9h
                jne     PatchDiv0Ent_err

                inc     di
                mov     ax,es:[di]
                cmp     ax,0F4Fh
                jne     PatchDiv0Ent_err
                mov     ax,0FD5h
                stosw
                mov     di,0FE4h+4+DATA_OFFSET
                mov     ax,0FD8h
                stosw
                clc
                ret
PatchDiv0Ent_err:
                stc
                ret
PatchDiv0Ent    ENDP
;--------------------------------------------------------------------------
;       PatchDiv0
;--------------------------------------------------------------------------
PatchDiv0       PROC   near
                mov     es,DataBufferSeg
                mov     di,0FD8h+DATA_OFFSET        ; ROM DATA dependent value
                mov     si,offset div0recover
                mov     cx,offset div0recover_E - offset div0recover
        rep     movsb
                clc
                ret
PatchDiv0       ENDP

;--------------------------------------------------------------------------
;       Patch8192Cyln   
;--------------------------------------------------------------------------
Patch8192Cyln   PROC   near
                mov     es,DataBufferSeg
; CodePatch
                mov     di,0083h ; com addr 0183h
                mov     ax,es:[di]
                cmp     ax,0FEEBh       ; jmp $ 
                jne     @f
                mov     ax,0E6EBh       ; at 0183h jmp 16Bh (+100h)
                stosw
        @@:     
; patch0        ; 8GBΉł͖gp
                mov     si,offset E10code0
                mov     cx,( offset E10code0_end - offset E10code0 )
                mov     di,0FC0h
                mov     dx,1000h
                push    cx
                call    scan_string
                pop     cx
                jc      No_match
                mov     di,bx
                mov     si,offset E10patch0
           rep  movsb

; patch1
                mov     si,offset IFN92code1
                mov     cx,offset ( IFN92code1_E - offset IFN92code1 )
                mov     di,0FC0h
                mov     dx,1000h
                push    cx
                call    scan_string
                pop     cx
                jc      No_match
                mov     di,bx   ; 
                mov     si,offset IFN92pat1
           rep  movsb

; patch3
                mov     si,offset IFN92code3
                mov     cx,offset ( IFN92code3_E - offset IFN92code3 )
                mov     di,0FC0h
                mov     dx,1000h
                push    cx
                call    scan_string
                pop     cx
                jc      No_match
                mov     di,bx   ; 
                mov     si,offset IFN92pat3
           rep  movsb

IF 1    ; 8GBւ̑Ή
; patch2
                mov     si,offset IFN92code2
                mov     cx,( offset IFN92code2_E - offset IFN92code2)
                mov     di,0FC0h
                mov     dx,1000h
                push    cx
                call    scan_string
                pop     cx
                jc      No_match
                mov     di,bx   ; 
                mov     si,offset IFN92pat2
         rep    movsb

; patch4
                mov     si,offset E10code4
                mov     cx,( offset E10code4_end - offset E10code4)
                mov     di,0FC0h
                mov     dx,1000h
                push    cx
                call    scan_string
                pop     cx
                jc      No_match
                mov     di,bx   ; 
                mov     si,offset E10patch4
         rep    movsb
ENDIF
                mov     si,offset VersionString   
                mov     cx,(offset VersionString2 - offset VersionString )
                mov     di,0FC0h
                mov     dx,3FF0h
                push    cx
                call    scan_string
                pop     cx
                jc      @f
                mov     di,bx   ; 
                mov     si,offset VersionString2
         rep    movsb
        @@:     nop
                clc
                ret
No_match:       
                stc
                ret
Patch8192Cyln   ENDP

;--------------------------------------------------------------------------
;       Jmp2_Out5f      2023-5-25 C (V1.32)
;--------------------------------------------------------------------------
Jmp2_Out5f      PROC   near
                mov     es,DataBufferSeg        ; es:diobt@
                mov     di,DataBufferOfs        ; di0̔0̏ꍇłΉ
                add     di,DATA_OFFSET+30h      ; di̓f[^Jn_{30hɈʒu
                mov     cx,DATA_OFFSET+4000h-30h ;ROMf[^̑傫܂
                add     cx,di                   ; cx̓obt@Ō̃AhX
                
Jmp_Out5f_ent:
                mov     ax,es:[di]      ; 1[hǂ
                cmp     ax, 00EBh       ; JMP $+2 ( EB 00 )̖߂H
                jnz     @f              ; pX
                call    PrintAddrDI     ; l\
                mov     ax,5FE6h        ; OUT 5Fh,al ( E6 5F )̖
                mov     es:[di],ax      ; 𖄂ߍ
           @@:  nop
                inc     di              ; ̃AhX
                cmp     di,cx           ; Ō̃AhXɓBĂ邩H
                jb      Jmp_Out5f_ent   ; Ȃ烋[vp
                mov     di,DataBufferOfs        ; es:diɖ߂Ă
                ret
Jmp2_Out5f      ENDP

if 0
;--------------------------------------------------------------------------
;       CheckSum4KB_4    
;--------------------------------------------------------------------------
SumBlockSize    equ     1000h
CheckSum4KB_4   PROC   near
                mov     di,DataBufferOfs
                mov     es,DataBufferSeg
;Block0000
                mov     dx,0
                mov     di,0000h
                mov     es:[1000h-2],dx
                mov     cx,(SumBlockSize/2)-1
        @@:     mov     ax,es:[di]
                add     dl,al
                add     dh,ah
                inc     di
                inc     di
               Loop     @b
                neg     dl
                neg     dh
                mov     ax,dx
                stosw

;Block1000
                mov     dx,0
                mov     di,1000h
                mov     es:[2000h-2],dx
                mov     cx,(SumBlockSize/2)-1
        @@:     mov     ax,es:[di]
                add     dl,al
                add     dh,ah
                inc     di
                inc     di
               Loop     @b
                neg     dl
                neg     dh
                mov     ax,dx
                stosw

                ret
CheckSum4KB_4   ENDP
endif

;-----------------------------------------------------------------
;       fBXNI/Ô߂̃obt@m
;-----------------------------------------------------------------
        PUBLIC  AllocateBuf 
AllocateBuf     PROC    near
                mov     bx,0800h        ; paragraph size, 32KBm
                inc     bx
                mov     ah,48h          ; ZOg𓾂
                int     21h
                jc      mem_a_error
                mov     DataBufferSeg,ax
                mov     dx,ax           ; ZOgFOԂ
                xor     ax,ax
                mov     DataBufferOfs,ax
                mov     di,ax
                mov     cx,8000h/2      ; 32KB(16KW) [ŏ
                mov     es,dx
            rep stosw
                clc
                ret
mem_a_error:    mov     dx,offset err_mAllocFail
                call    puts
                stc
                ret
AllocateBuf     ENDP
err_mAllocFail  DB "̋󂫂sĂ̂ősł܂.",13,10,0

;---------------------------------------------------------------
;       SaveToFile      
;---------------------------------------------------------------
SaveToFile      PROC    near
                mov     dx,offset OutputFileName
                call    puts
                mov     dx, offset OutputFileName
                mov     cx, 0020h       ; VK쐬
                mov     ax,3C00h        ; ݂ŃI[v
                xor     bx,bx
                int     21h
                jc      creat_err
                mov     DOS_handle,ax
                mov     bx,ax; DOS_handle
                mov     cx,ROM_DATA_SIZE
                mov     dx,DataBufferOfs
                mov     ax,DataBufferSeg
                 push    ds
                 mov     ds,ax
                 mov     ax,4000h     ; write to file
                 int 21h
                 pop     ds
                jc      write_err
                cmp     ax,ROM_DATA_SIZE
                jnz     write_err

                mov     bx,DOS_handle
                mov     ah,3Eh          ; CloseFile
                xor     dx,dx
                int     21h
                mov     dx,offset MsgSaved
                call    puts
                mov     dx,offset CRLF
                call    puts
                clc
ExitSaveFile:   mov     DOS_handle,-1
                ret
creat_err:      mov     dx,offset CreatErrMsg
                jmp     DOSabend
write_err:      mov     dx,offset WriteErrMsg
                jmp     DOSabend
data_err:       mov     dx,offset DataErrMsg
                jmp     DOSabend
DOSabend:       call    puts
                stc
                jmp     ExitSaveFile
MsgSaved        DB "  t@C쐬܂. ",13,10,0
CreatErrMsg     DB "  t@C̍쐬Ŏs܂. ",13,10,0
WriteErrMsg     DB "  t@C݂Ŏs܂.",13,10,0
DataErrMsg      DB "  f[^G[ł."
DOS_handle      DW      -1
SaveToFile      ENDP

;-----------------------------------------------------------------
;       LoadFile        DS:DX   = file buffer
;-----------------------------------------------------------------
LoadFile        PROC    near
                mov     dx,offset InputFileName
                call    puts
                mov     ax,3D00h
                xor     bx,bx
                int 21h
                jc      open_err1
                mov     DOS_handle,ax
                mov     dx,offset MsgLoaded
                call    puts
; phase1                
                mov     ax,DataBufferSeg
                mov     dx,DataBufferOfs
                mov     cx,ROM_DATA_SIZE
                mov     bx,DOS_handle   ; int21, func 3F
                push    ds
                 mov     ds,ax
                 mov     ax,3F00h        ; DOS function call (read)
                 int 21h
                pop     ds
                jc      read_err2
                cmp     ax,ROM_DATA_SIZE
                jne     read_err2

                mov     bx,DOS_handle           ; close 
                mov     ah,3Eh
                xor     dx,dx
                int     21h
                mov     DOS_handle,-1
                clc
                ret
open_err1:      
                mov     dx,offset OpenErrMsg
                call    puts
                mov     dx,offset ProgramTitle2
                call    puts
                jmp     read_err_e
read_err2:      
                mov     dx,offset ReadErrMsg
                call    puts
read_err_e:     mov     bx,DOS_handle       ; close
                mov     ah,3Eh
                xor     dx,dx
                int     21h
                stc
                ret
MsgLoaded       DB "  t@CǍ݂܂. ",13,10,0
OpenErrMsg      DB "  t@CJgfBNgɑ݂Ă܂. ",13,10,0
ReadErrMsg      DB "  t@CǍ݂Ŏs܂.",13,10,0

LoadFile        ENDP


;--------------------------------------------------------------------------
;       ShortBeep
;--------------------------------------------------------------------------
Wait5           PROC   near
        @@:     out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
               loop     @b
                ret
Wait5           ENDP
ShortBeep       PROC   near
                push    cx
                push    ax
                mov     al,6
                out     37h,al
                mov     cx,1234
                call    Wait5
                mov     al,7
                out     37h,al
                pop     ax
                pop     cx
                ret
ShortBeep       ENDP

;--------------------------------------------------------------------------
;       machine_check   
;--------------------------------------------------------------------------
machine_check   PROC   near     
                mov     ah,00
                mov     cx,0FFFFh       ; 悭mꂽ98/AT`FbN
                int 1Ah
                cmp     cx,0FFFFh
                jNE     NotPC98  
                clc
                ret
NotPC98:        
                mov     dx,offset msg_not98
                call    puts  ; int 21ŕ\
                stc
                ret
machine_check   ENDP

;------------------------------------------------------------------------
;   PrintAddrDI   DI̐l\Zi4El, 擪Xy[X܂5ŕ\
;------------------------------------------------------------------------
PrintAddrDI     PROC   near
                pusha
                mov     bx,offset DecimalString+4
                mov     dx,di
                mov     cx,4
Ent4:           mov     ah,dl
                and     ah,0Fh
                cmp     ah,09
                ja      Hexa
                mov     al,30h
                add     al,ah
                jmp     both9X
        Hexa:
                mov     al,37h
                add     al,ah
both9X:         mov     ds:[bx],al
                dec     bx
                shr     dx,4
               loop     Ent4

                mov     dx,offset DecimalString
                call    puts
                popa
                ret
DecimalString   DB      20h,20h,20h,20h,20h,0
PrintAddrDI     ENDP


;-----------------------------------------------------------------
;       puts in MS-DOS
;-----------------------------------------------------------------
puts            PROC   near
                push    si
                push    dx
                push    ax
                mov     si,dx
entry_puts:     mov     dl,cs:[si]
                or      dl,dl
                jz      @f
                mov     ah,2
                int     21h
                inc     si
                jmp     entry_puts
      @@:       pop     ax
                pop     dx
                pop     si
                ret
puts            ENDP

.386
;--------------------------------------------------------------------------
;       BSWAP   EAX             9 bytes
;--------------------------------------------------------------------------
ByteSwap_EAX    label   byte
                xchg    al,ah
                rol     eax,16
                xchg    al,ah
                ret
ByteSwap_EAX_E  label   byte

;--------------------------------------------------------------------------
;  SCSI BIOS 1GBӏR[h ^ 8GBǃR[h
;--------------------------------------------------------------------------
E10code0        label   byte
                and     dx,00FFh      ; mask 24bit
                div     bx
E10code0_end    label   byte

E10patch0       label   byte
                and     dx,0FFFh      ; mask 28bit ; 81E2FF0F
                div     bx            ;
E10patch0_end   label   byte

E10code4        label byte
                mov     [bp+56h],dl
                xchg    ah,al
E10code4_end    label byte

E10patch4       label byte
                mov     [bp+56h],dx
                xchg    ah,al
E10patch4_end   label byte

;----------------o[W 1.30ő傫 -------
IFN92code1     label   byte
       test    byte ptr [bp+50h],80h   ;000AA7 F6465080 
       jnz     $+2+08h    ;to 0AB5     ;000AAB 7508     
       mov     dl,[bp+56h]             ;000AAD 8A5656   
       mov     ax,[bp+54h]             ;000AB0 8B4654   
       jmp     $+2+24h    ;to 0AD9     ;000AB3 EB24     

       DB 0E8h,76h,00h ;  call 0B2E    ;00AB5 E87600   
       mov     al,[bx+01h]             ;00AB8 8A4701   
       and     al,0Fh                  ;00ABB 240F     
       xor     ah,ah                   ;00ABD 32E4     
       mov     cx,[bp+54h]             ;00ABF 8B4E54   
       mul     cx                      ;00AC2 F7E1     
       add     al,[bp+57h]             ;00AC4 024657   
       adc     ah,00h                  ;00AC7 80D400   
       mov     cl,[bx]                 ;00ACA 8A0F     
       xor     ch,ch                   ;00ACC 32ED     
       mul     cx                      ;00ACE F7E1     
       add     al,[bp+56h]             ;00AD0 024656   
       adc     ah,00h                  ;00AD3 80D400   
       adc     dx,+00h                 ;00AD6 83D200   
       mov     [bp+07h],dl             ;00AD9 885607   
       mov     [bp+08h],ah             ;00ADC 886608   
       mov     [bp+09h],al             ;00ADF 884609   
       ret                             ;00AE2 C3       
; ̃[`
       mov     cl,[bx+03h]              ;0AE3 8A4F03   
       and     cl,30h                   ;0AE6 80E130   
       mov     ax,0100h                 ;0AE9 B80001   
       shr     cl,1                     ;0AEC D0E9     
       shr     cl,1                     ;0AEE D0E9     
       shr     cl,1                     ;0AF0 D0E9     
       shr     cl,1                     ;0AF2 D0E9     
       shl     ah,cl                    ;0AF4 D2E4     
       ret                              ;0AF6 C3       
IFN92code1_E     label   byte

IFN92pat1       label   byte
      mov     eax,[bp+54h]             ;0AA7 668B4654  
      bswap   eax                      ;0AAB 660FC8    
      test    byte ptr [bp+50h],80h    ;0AAE F6465080 1byteOɈړ
      jz      IFN92pat1_2;  to 0ADEh   ;0AB2 7429      
      DB 0E8h,77h,00h ;  call  0B2Eh   ;0AB4 E87700    
      mov     al,[bx+01h]              ;0AB7 8A4701    
      and     al,0Fh                   ;0ABA 240F      
      movzx   ecx,al                   ;0ABC 660FB6C8  
      movzx   eax,word ptr [bp+54h]    ;0AC0 660FB74654
      mul     ecx                      ;0AC5 66F7E1    
      mov     cl,[bp+57h]              ;0AC8 8A4E57    
      add     eax,ecx                  ;0ACB 6603C1    
      mov     cl,[bx]                  ;0ACE 8A0F      
      mul     ecx                      ;0AD0 66F7E1    
      mov     cl,[bp+56h]              ;0AD3 8A4E56    
      add     eax,ecx                  ;0AD4 6603C1    
      bswap   eax                      ;0AD9 660FC8    
IFN92pat1_2:    ; Oɋl߂Ă
      mov     [bp+06h],eax             ;0ADC 66894606  
      ret                              ;0AE0 C3        
      NOP                              ;0AE1

; XƊ֌ŴȂA24bit̂߂̃[`̋󂫂Ɋ荞܂
      mov     dx,[bp+13h]              ; 0AE2 8B5613    
      xchg    dl,dh                    ; 0AE5 86D6      
      ret                              ; 0AE7 C3

; ̃[`  (0AE8)ɋl߂Ă
       mov     cl,[bx+03h]              ;0AE8  8A4F03   
       and     cl,30h                   ;0AEB  80E130   
       mov     ax,0100h                 ;0AFE  B80001   
       shr     cl,4                     ;0AF1
       shl     ah,cl                    ;0AF4  D2E4     猳ƓAhX
       ret                              ;0AF6  C3       
IFN92pat1_E      label   byte

IFN92code2      label byte
                mov     dl,[bp+14h]
                mov     ax,[bp+15h]
                test    byte ptr [bp+10h],80h
IFN92code2_E    label byte

IFN92pat2       label byte
                DB      0E8h,0B0h,01h   ; at 092F --> call 0AE2
                mov     ax,[bp+15h]
                test    byte ptr [bp+10h],80h
IFN92pat2_E     label byte


IFN92code3       label   byte
        mov     [bp+54h],ax
        DB      0E8h,12h,03h    ; call get_offset0460_from_ID
IFN92code3_E    label   byte

IFN92pat3       label   byte
        mov     [bp+54h],ax
        DB      0E8h,17h,03h    ; call get_offset0460_from_ID
IFN92pat3_E    label   byte


SetVector00     label byte      ; DS=0  org 0FE4h
                mov     word ptr ds:[0],0FD8h
                mov     word ptr ds:[2],cs
                DB      0E9h
SetVector00_JMP DW      0FF6Dh
SetVector00_E   label byte

div0recover     label byte      ; org 0FD8h
                pop     ax      ; retrive previous stack
                inc     ax      ; 2 byte before the called addresss 
                inc     ax
                push    ax      ; store the adress to stack memory
                xor     dx,dx            ; return value of DX:AX is set to
                mov     ax,0FFFEh       ; maximum of 16bit -1 
                iret            ; resume instruction
div0recover_E   label byte

;==========================================================================
VersionString   DB      "Ver2.13.92  95/10/01"
VersionString2  DB      "Ver2.13.92R  2023",0F2h,"5",0F3h

;--------------------------------------------------------------------
;       scan_string  386   ̔r[`  
;       <input>
;       DS:SI rp^[,         CX p^[̃oCg
;       ES:DI p^[ꏊ,         DX ͈̔̓oCg
;       <output>        < j SẴWX^ >
;       CY =NONE ,  NC= ES:BX   carry0̂Ƃ  ES:BXɌoꏊԂ
;--------------------------------------------------------------------
scan_string     PROC    near
                xor     bx,bx
                add     dx,di
scan_ent:       mov     eax,ds:[si]
                cmp     eax,es:[di]
                jnz     scan_No_match
                mov     bx,di
                push    si
                push    di
         repz   cmpsb
                or      cx,cx
                pop     di
                pop     si
                jnz     scan_No_match
                clc                     ; scan OK
                ret
scan_No_match:  
                cmp     di,dx
                jae     @f
                inc     di
                jmp     scan_ent
        @@:     
                stc                     ; scan NG
                ret
scan_string     ENDP


;------------------------------------
StackBase       label   byte


code    ends
        end     start
